# Pokedex GO API

Pokedex for Pokemon GO API by PMK Group Development

## PMK Group Development members

|  Name | StudentID   |  Git |
|---|---|---|
| Chayathon Khuttiyanon     | 6110546381    | [plumest](https://github.com/plumest)               |
| Sirawich Direkwattanachai | 6110546054    | [magmagcup](https://github.com/magmagcup)           |
| Kritpawit Soongswang      | 6110545414    | [kornkritpawit](https://github.com/kornkritpawit)   |

> All of our team members come from *Software and Knowledge Engineering*


## Acknowledgement 

Every Pokemon pictures in this project come from [gamepress](https://gamepress.gg/pokemongo/pokemon-list) 
and [db.pokemongohub](https://db.pokemongohub.net/)  


## Requirement

* MySQL
* Python 3.8 or newer
* Python add-on modules as in [requirements.txt](requirements.txt)
> You don't need to manually download module in requirements.txt 
>yourself because we already provided installation command
> in the following section

#### For scraping
> You can ignore this if you don't need to scrap 
> new data from the following website: [gamepress](https://gamepress.gg/pokemongo/pokemon-list) 
and [db.pokemongohub](https://db.pokemongohub.net/) 

* beautifulsoup4
* requests
* selenium
* Chromedriver



## Installation
```
macOS or Linux
$ python3 -m venv venv
$ . venv/bin/activate

Windows
$ python -m venv venv
$ venv\Scripts\activate.bat 
```
Then both OS can continue with this commands
```shell script
$ java -jar openapi-generator-cli-4.3.1.jar generate -i openapi/pokedex-go-api.yaml -o autogen -g python-flask
$ pip install -r requirements.txt
```

## Load data
In root directory
```shell script
$ brew install mysql
$ mysql.server start
$ mysql -uroot

mysql> SET GLOBAL local_infile=1;
mysql> quit

$ mysql --local-infile=1 -uroot < data/scripts/load_data.sql
```

## Usage
```shell script
$ python app.py
```
Optionally test the API at http://localhost:8080/pokedex-go-api/v1/ui
```shell script
$ openapi-to-graphql --cors -u http://localhost:8080/pokedex-go-api/v1 openapi/pokedex-go-api.yaml
```
Open the page http://localhost:3000/graphql

