import csv
from selenium import webdriver
import urllib.request
import time
from bs4 import BeautifulSoup
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

LINK = "https://db.pokemongohub.net"
GEN = 8
POKEINDEX = "https://db.pokemongohub.net/pokemon-list/gen-"
FILENAME = "../linkdata/pokehublink.txt"
# RANGE = 863
RANGE = 1
chromeDriverPath = "chrome_driver/chromedriver.exe"


def poke_link():
    f = open("../linkdata/pokehublink.txt", "a")
    browser = webdriver.Chrome()
    for i in range(1, GEN):
        link = POKEINDEX + str(i)
        browser.get(link)
        WebDriverWait(browser, 10).until(
            EC.presence_of_element_located((By.CLASS_NAME, "rt-tbody"))
        )
        soup = BeautifulSoup(browser.page_source, 'html.parser')
        pokemon_links = [LINK + link_section.get('href') for link_section in soup.findAll("a", {"class": "pokemon-link"})]

        browser.find_element(By.XPATH, '//button[text()="Next"]').click()
        WebDriverWait(browser, 120).until(
            EC.presence_of_element_located((By.CLASS_NAME, "rt-tbody"))
        )
        soup = BeautifulSoup(browser.page_source, 'html.parser')
        pokemon_links_second_page = [LINK + link_section.get('href') for link_section in soup.findAll("a", {"class": "pokemon-link"})]

        for link in pokemon_links:
            f.write(link + "\n")
        for link in pokemon_links_second_page:
            f.write(link + "\n")
    f.close()


def get_all_field() -> list:
    browser = webdriver.Chrome()
    poke_data = []

    for link in read_file():
        status = False
        try:
            browser.get(link)
            element = WebDriverWait(browser, 10).until(
                EC.presence_of_element_located((By.CLASS_NAME, "pokemon--header"))
            )

            soup = BeautifulSoup(browser.page_source, 'html.parser')
            pokemon_page_section = soup.find("div", {"class": "pokemon-page"})
            pokemon_page_head = pokemon_page_section.find("nav", {"class": "pokemon--header"})
            pokemon_page_detail = pokemon_page_section.find("div", {"class": "pokemon--details"})

            name_form = get_name_id(pokemon_page_head)
            pic_or_vid = get_pokemon_pic(pokemon_page_detail)
            name_form.append(pic_or_vid)
            poke_data.append(name_form)
            status = True
            time.sleep(5)
        except:
            time.sleep(5)

    return poke_data


def get_debug_all_field() -> list:
    browser = webdriver.Chrome()
    poke_data = []
    # for link in read_file():
    #     status = False
    link = 'https://db.pokemongohub.net/pokemon/122'
    browser.get(link)
    element = WebDriverWait(browser, 10).until(
        EC.presence_of_element_located((By.CLASS_NAME, "pokemon--header"))
    )

    soup = BeautifulSoup(browser.page_source, 'html.parser')
    pokemon_page_section = soup.find("div", {"class": "pokemon-page"})
    pokemon_page_head = pokemon_page_section.find("nav", {"class": "pokemon--header"})
    pokemon_page_detail = pokemon_page_section.find("div", {"class": "pokemon--details"})

    name_form = get_name_id(pokemon_page_head)
    pic_or_vid = get_pokemon_pic(pokemon_page_detail)
    name_form.append(pic_or_vid)
    poke_data.append(name_form)
    status = True
    time.sleep(5)
    return poke_data


def get_pokemon_pic(pokemon_page_detail):
    pic_or_vid_section = pokemon_page_detail.find("div", {"class": "card image-and-type"})
    try:
        pic = pic_or_vid_section.find("source", {"type": "image/png"}).attrs
        return LINK + pic['srcset']
    except AttributeError:
        vid = pic_or_vid_section.find("source", {"type": "video/mp4"}).attrs
        return LINK + vid['src']


def get_name_id(pokemon_page_head) -> list:
    poke_id = pokemon_page_head.find("small").getText()[2:]
    full_name = pokemon_page_head.find("h1").getText()
    name_form = full_name.split(' ')
    form_name = name_form[1]
    poke_name = name_form[0]
    if form_name != '' and len(name_form) == 2:
        if name_form[1][:1] == '(':
            form_name = split_form(form_name)
        else:
            poke_name = poke_name + ' ' + form_name
            form_name = ''

    if form_name != '' and len(name_form) == 3:
        if name_form[1][:1] == '(':
            full_from = name_form[1] + ' ' + name_form[2]
            form_name = split_form(full_from)
        else:
            poke_name = poke_name + ' ' + name_form[1]
            form_name = name_form[2]

    return [poke_id, poke_name, form_name]


def split_form(form) -> str:
    print(form[1:-1])
    return form[1:-1]


def read_file():
    f = open(FILENAME, "r")
    return f.read().splitlines()


index = 0
all_poke_data = get_all_field()
with open('../data/csv/high_quality_image.csv', 'w', newline='', encoding='utf8') as file:
    writer = csv.writer(file)
    writer.writerow(["ID", "Name", "Form", "Link"])
    for each_poke_data in all_poke_data:
        writer.writerow(each_poke_data)
